FUNCTION_BLOCK SFC_MASTER
  VAR_INPUT
    INPUT : BOOL;
  END_VAR
  VAR_OUTPUT
    SOSPENDI : BOOL;
    ACCENDI : BOOL;
  END_VAR
  VAR
    R_TRIG1 : R_TRIG;
    R_TRIG2 : R_TRIG;
  END_VAR

  INITIAL_STEP Spento:
    SOSPENDI(N);
    COMPUTE_FUNCTION_BLOCKS(S);
  END_STEP

  ACTION COMPUTE_FUNCTION_BLOCKS:
    R_TRIG1(CLK := INPUT);
    R_TRIG2(CLK := INPUT);
  END_ACTION

  TRANSITION FROM Spento TO Acceso
    := R_TRIG2.Q;
  END_TRANSITION

  STEP Acceso:
    ACCENDI(N);
  END_STEP

  TRANSITION FROM Acceso TO Spento
    := R_TRIG1.Q;
  END_TRANSITION

END_FUNCTION_BLOCK

FUNCTION_BLOCK SFC_ONDA
  VAR_INPUT
    FORZATO : BOOL;
    SOSPESO : BOOL;
  END_VAR
  VAR_OUTPUT
    OUTPUT : BOOL;
  END_VAR

  INITIAL_STEP SPENTO:
  END_STEP

  TRANSITION FROM SPENTO TO ONDA_ON
    := FORZATO;
  END_TRANSITION

  STEP ONDA_ON:
    OUTPUT(N);
  END_STEP

  TRANSITION FROM ONDA_ON TO ONDA_OFF
    := (ONDA_ON.T>=T#4s) AND (NOT SOSPESO);
  END_TRANSITION

  STEP ONDA_OFF:
  END_STEP

  TRANSITION FROM ONDA_OFF TO SPENTO
    := SOSPESO;
  END_TRANSITION

  TRANSITION FROM ONDA_OFF TO ONDA_ON
    := (ONDA_OFF.T>=T#6s) AND (NOT SOSPESO);
  END_TRANSITION

  TRANSITION FROM ONDA_ON TO SPENTO
    := SOSPESO;
  END_TRANSITION

END_FUNCTION_BLOCK

PROGRAM Main
  VAR
    IN : BOOL;
    MASTER : SFC_MASTER;
    OUT : BOOL;
    ONDA : SFC_ONDA;
  END_VAR

  MASTER(INPUT:=IN);
  ONDA(FORZATO:=MASTER.ACCENDI,SOSPESO:=MASTER.SOSPENDI);
  OUT:=ONDA.OUTPUT;
END_PROGRAM


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK CicloACopiaMassiva(INTERVAL := T#100ms,PRIORITY := 0);
    PROGRAM instance0 WITH CicloACopiaMassiva : Main;
  END_RESOURCE
END_CONFIGURATION
